# Mars3D三维地球平台

<p>
<a target="_black" href="https://www.npmjs.com/package/mars3d">
<img alt="Npm version" src="https://img.shields.io/npm/v/mars3d.svg?style=flat&logo=npm&label=version"/>
</a>
<a target="_black" href="https://github.com/marsgis/mars3d">
<img alt="GitHub stars" src="https://img.shields.io/github/stars/marsgis/mars3d?style=flat&logo=github">
</a> 
<a target="_black" href="https://www.npmjs.com/package/mars3d">
<img alt="Npm downloads" src="https://img.shields.io/npm/dt/mars3d?style=flat&logo=npm">
</a>
</p>

 
 `Mars3D三维地球平台软件` 是[火星科技](http://marsgis.cn/)研发的一款基于 WebGL 技术实现的三维客户端开发平台，基于[Cesium](https://cesium.com/cesiumjs/)优化提升与B/S架构设计，支持多行业扩展的轻量级高效能GIS开发平台，能够免安装、无插件地在浏览器中高效运行，并可快速接入与使用多种GIS数据和三维模型，呈现三维空间的可视化，完成平台在不同行业的灵活应用。

 Mars3D平台可用于构建无插件、跨操作系统、 跨浏览器的三维 GIS 应用程序。平台使用 WebGL 来进行硬件加速图形化，跨平台、跨浏览器来实现真正的动态大数据三维可视化。通过 Mars3D产品可快速实现浏览器和移动端上美观、流畅的三维地图呈现与空间分析。


> 开发教程：[http://mars3d.cn/dev/](http://mars3d.cn/dev/)  
> API文档：[http://mars3d.cn/api/](http://mars3d.cn/api/)  
> 功能示例：[https://github.com/marsgis/mars3d](https://github.com/marsgis/mars3d)    
> 功能示例（国内）：[ https://gitee.com/marsgis/mars3d]( https://gitee.com/marsgis/mars3d)

更多资料请访问Mars3D官网：[http://mars3d.cn](http://mars3d.cn)  


## **本仓库说明** 

### 运行站点
 在任意开发编辑器（如vscode等）或http服务器(如node、nginx、tomcat、IIS等)下直接运行浏览`examples.html`即可

> 运行效果 
 [在线预览](http://mars3d.cn/examples.html)  
 
### 反馈问题
 为了方便交流及留存，所有bug及建议均统一提交至：
>  [https://github.com/marsgis/mars3d/issues](https://github.com/marsgis/mars3d/issues)  


## 开源仓库导航 

### 传统技术栈(原生JS)
1. 最简项目[https://github.com/marsgis/mars3d-es5-template](https://github.com/marsgis/mars3d-es5-template)
2. 基础项目(widget模式)[https://github.com/marsgis/mars3d-es5-widget](https://github.com/marsgis/mars3d-es5-widget)


### Vue技术栈
1. 最简项目[https://github.com/marsgis/mars3d-vue-template](https://github.com/marsgis/mars3d-vue-template)

2. 最简项目(本地版)[https://github.com/marsgis/mars3d-vue-template-local](https://github.com/marsgis/mars3d-vue-template-local)    `mars3d库非npm引入`

3. 基础项目(widget模式)[https://github.com/marsgis/mars3d-vue-widget](https://github.com/marsgis/mars3d-vue-widget)

4. CS桌面程序项目 [https://github.com/marsgis/mars3d-vue-electron](https://github.com/marsgis/mars3d-vue-electron)


### React技术栈
1. 最简项目[https://github.com/marsgis/mars3d-react-template](https://github.com/marsgis/mars3d-react-template)


### Angular技术栈 
1. 最简项目[https://github.com/marsgis/mars3d-angular-template](https://github.com/marsgis/mars3d-angular-template)



### 其他Cesium技术栈
 
1. 超图集成示例[https://github.com/marsgis/mars3d-link-supermap](https://github.com/marsgis/mars3d-link-supermap)

 

## 运行效果  
 功能示例：
 ![image](http://mars3d.cn/img/example.jpg)
 
 基础项目：[在线体验](http://mars3d.cn/project/jcxm/index.html)

 ![image](http://mars3d.cn/img/jcxm.jpg)
 
 电子沙盘项目：[在线体验](http://mars3d.cn/project/dzsp/login.html)

 ![image](http://mars3d.cn/img/dzsp.jpg)
 
 综合态势项目：[在线体验](http://mars3d.cn/project/zhts/index.html)

 ![image](http://mars3d.cn/img/zhts.jpg)


## 版权说明
1. 任何`个人或组织`可以在遵守Mars3D相关要求下`免费无限制`使用。
2. 如有`个性化需求`或`商业应用`，请联系[火星科技](http://mars3d.cn)购买。