// 根据服务器配置ip初始化地图
function setServerMapCDNConfigIp() {
    const xhr = new XMLHttpRequest();
    xhr.responseType = 'json';
    $.ajax({
            url: 'https://wm.oxgrass.com/v1/scenic/map/cdn/config',
            async: false,
            type: "GET",
            success: function (data, status) {
                try {
                    cdnConfig = data.data;
                } catch (e) {
                    console.log(e)
                }
                // 根据陪文件和ip地址初始化地图
            }
        }
    );
}

// 获取服务器配置ip
function getServerConfigIp() {
    // 设置默认缓存
    let ip = 'mapc1.en90.com';
    const xhr = new XMLHttpRequest();
    xhr.responseType = 'json';
    $.ajax({
            url: 'https://wm.oxgrass.com/v1/scenic/map/config',
            async: false,
            type: "GET",
            success: function (data, status) {
                try {
                    ip = data.data.ip;
                    inlandDomain = data.data.inlandDomain;
                } catch (e) {
                    console.log(e)
                }
                // 根据陪文件和ip地址初始化地图
            }
        }
    );
    serverIp = ip;
    return ip;
}

// 对外接口
function getClickLocation() {
    // 获取点击点坐标
    return clickLocation;
}

function getPanoStatus() {
    // 获取当前是否处于街景状态
    return displayStreetViewLayer;
}

function setMyLocation(data) {
    let location = JSON.parse(data);
    // 设置当前位置
    let c = gcj02towgs84(location.longitude, location.latitude);
    location.latitude = c[1];
    location.longitude = c[0];
    myLocation = {lat: location.latitude, lng: location.longitude, alt: location.altitude, heading: 0, pitch: -90}
}

// 跳转到接收外部传入坐标，并调用外部js方法
function flyToPosition(data) {
    let location = JSON.parse(data);
    // 设置坐标缓存
    set_cache(streetViewLocationCacheKey, data);
    let c = gcj02towgs84(location.longitude, location.latitude);
    location.latitude = c[1];
    location.longitude = c[0];

    // 跳转到响应坐标
    map.flyToPoint({
        lat: location.latitude,
        lng: location.longitude,
        alt: location.altitude,
        heading: 0,
        pitch: -90
    }, {radius: 1, maximumHeight: 7986317, complete: openStreetView, duration: 3});
}

// 跳转到接收外部传入坐标，并调用外部js方法
function flyToPositionNotOpenPano(data) {
    let location = JSON.parse(data);
    // 设置坐标缓存
    set_cache(streetViewLocationCacheKey, data);
    let c = gcj02towgs84(location.longitude, location.latitude);
    location.latitude = c[1];
    location.longitude = c[0];

    // 跳转到响应坐标
    map.flyToPoint({
        lat: location.latitude,
        lng: location.longitude,
        alt: location.altitude,
        heading: 0,
        pitch: -90
    }, {radius: 1, maximumHeight: 7986317, duration: 3});
}

// 相机移动事件
function bindCameraChanged(map) {
    map.on(mars3d.EventType.cameraChanged, cameraChangedNotification);
}

// 通知原生，当前地图层级
function cameraChangedNotification() {
//     nativeinject.currentLevel(map.level);
    let location = map.getCameraView();
    location.level = map.level;
    console.log("cameraChangedNotification" + JSON.stringify(location));
}

// 鼠标绑定/解绑
// 绑定点击事件
function bindMouseClickEvent(obj) {
    console.log('绑定图层点击事件');
    obj.on(mars3d.EventType.click, dealClickEvent);
}

// 解除绑定点击事件
function unbindClickEvent(obj) {
    console.log('解绑地图点击事件');
    obj.off(mars3d.EventType.click, dealClickEvent);
}

// 处理鼠标点击事件
function dealClickEvent(event) {
    console.log("dealClickEvent");
    //单击事件
    let cartographic = Cesium.Cartographic.fromCartesian(event.cartesian);
    let longitude = Cesium.Math.toDegrees(cartographic.longitude);
    let latitude = Cesium.Math.toDegrees(cartographic.latitude);
    // 获取街景
    getStreetPano(longitude, latitude);
}

//设置缓存
function set_cache(key, value) {
    localStorage.setItem(key, value);
}

// 读取缓存
function get_cache(key) {
    return localStorage.getItem(key);
}

// 清除缓存
function clear_cache() {
    localStorage.clear()
}

// 展示具体街景
// function getStreetPano(longitude, latitude) {
//     let url = `http://${cdnConfig.commonDomain}/v2/street/judge?longitude=${longitude}&latitude=${latitude}`;
//     const xhr = new XMLHttpRequest();
//     xhr.open('GET', url, true);
//     xhr.responseType = 'json';
//     xhr.onload = function () {
//         if (xhr.readyState === 4 && xhr.status === 200) {
//             // 调用外部view
//             if (isAndroid) {
//                 nativeinject.gotoStreetView(JSON.stringify(xhr.response));
//             }
//             if (isiOS) {
//                 window.webkit.messageHandlers.gotoStreetView.postMessage(JSON.stringify(xhr.response));
//             }
//         }
//     };
//     xhr.send();
// }

// 展示具体街景
function getStreetPano(longitude, latitude) {
    let center = map.getCenter();
    longitude = center.lng;
    latitude = center.lat;
    bdRes = {};
    ggRes = {};
    getBaiduStreetPano(longitude, latitude);
    if (bdRes.hasPano) {
        console.log('getStreetPano');
        callAppGotoStreetView(JSON.stringify(bdRes));
    } else {
        console.log('getStreetPano');
        getGoogleStreetPano(longitude, latitude);
        callAppGotoStreetView(JSON.stringify(ggRes));
    }
}

// 百度街景
function getBaiduStreetPano(longitude, latitude) {
    let url = `http://${inlandDomain}/panorama/baidu?longitude=${longitude}&latitude=${latitude}&crs=wgs84`;
    $.ajax({
            url: url,
            async: false,
            type: "GET",
            success: function (data, status) {
                try {
                    bdRes = data;
                } catch (e) {
                    console.log(e)
                }
                // 根据陪文件和ip地址初始化地图
            }
        }
    );
}

// 谷歌街景
function getGoogleStreetPano(longitude, latitude) {
    let url = `http://${cdnConfig.commonDomain}/panorama/google?longitude=${longitude}&latitude=${latitude}&crs=wgs84`;
    $.ajax({
            url: url,
            async: false,
            type: "GET",
            success: function (data, status) {
                try {
                    ggRes = data;
                } catch (e) {
                    console.log(e)
                }
                // 根据陪文件和ip地址初始化地图
            }
        }
    );
}

// 调用app打开街景方法
function callAppGotoStreetView(data) {
    let u = navigator.userAgent;
    let isAndroid = u.indexOf('Android') > -1 || u.indexOf('Adr') > -1; //android终端
    let isiOS = !!u.match(/\(i[^;]+;( U;)? CPU.+Mac OS X/); //ios终端
    // 调用外部view
    if (isAndroid) {
        nativeinject.gotoStreetView(data);
    }
    if (isiOS) {
        window.webkit.messageHandlers.gotoStreetView.postMessage(data);
    }
}

function zoomRestore() {
    let center = map.getCenter();
    console.log(center.lat + ", " + center.lng);
    // 跳转到响应坐标
    map.flyToPoint({
        lat: center.lat,
        lng: center.lng,
        alt: center.alt,
        heading: 0,
        pitch: -90
    }, {radius: 10000, maximumHeight: 7986317, duration: 0});
}

// 解除绑定点击事件
function bindCameraMoveEndEvent(obj) {
    console.log('绑定地图变化事件');
    map.on(mars3d.EventType.cameraMoveEnd, dealCameraMoveEndEvent);
}

// 处理鼠标点击事件
function dealCameraMoveEndEvent(event) {
    console.log("dealCameraMoveEndEvent：" + map.level);
    nativeinject.currentLevel(map.level);
}
